#! trimming function - not really more like doing drug design for each amplicon size
# from functools import partial
# from random import choices, randint, randrange, random, sample
# from typing import List, Optional, Callable, Tuple
import numpy as np
import time

# from geneticalgorithm import geneticalgorithm as ga
from rich_argparse import ArgumentDefaultsRichHelpFormatter
import pandas as pd
# from collections import Counter
# from tqdm import tqdm
# import time
# from Bio.SeqUtils import MeltingTemp
# from Bio import SeqIO
# from plotly import graph_objects as go
# import json
# from importlib import reload
from toast import primer_selection
# reload(primer_selection)
from toast import Amplicon_no
# reload(Amplicon_no)
from toast import working_algo_gene_2in1 as wa
# reload(w)
import argparse
from functools import reduce
import os
# import matplotlib.pyplot as plt
import pandas as pd
from toast import plotting1 as p
# from icecream import ic
from tabulate import tabulate
import re
from itertools import combinations


def user_defined(primer_input_file: str, refgenome: str, full_data: pd.DataFrame):
    primer_input = pd.read_csv(primer_input_file)
    pLeft_ID = []
    pLeft_coord = []
    pLeft_length = []
    pLeft_Sequences = []
    pRight_ID = []
    pRight_coord = []
    pRight_length = []
    pRight_Sequences = []
    Project_size = []
    Designed_ranges = []

    for i, x in primer_input.iterrows():
        # print(x)
        # print(x[0], x[1], x[2])
        # print(type(x[0]), type(x[1]), type(x[2]))
        pLeft_ID.append(x.iloc[2]+'-UserLeft')
        locl = primer_selection.find_sequence_location(x.iloc[0], refgenome)[0]
        pLeft_coord.append(locl)
        pLeft_length.append(len(x.iloc[0]))
        pLeft_Sequences.append(x.iloc[0])
        pRight_ID.append(x.iloc[2]+'-UserRight')
        locr = primer_selection.find_sequence_location(primer_selection.reverse_complement_sequence(x.iloc[1]), refgenome)[1]
        pRight_coord.append(locr)
        pRight_length.append(len(x.iloc[1]))
        pRight_Sequences.append(x.iloc[1])
        Project_size.append(locr - locl)
        Designed_ranges.append([locl, locr])
    
        full_data.loc[(full_data['genome_pos'] >= locl) & (full_data['genome_pos'] <= locr), 'weight'] = 0

    columns = ['pLeft_ID', 'pLeft_coord', 'pLeft_length', 'pLeft_Tm', 'pLeft_GC', 
                'pLeft_Sequences', 'pLeft_EndStability', 'pRight_ID', 'pRight_coord', 
                'pRight_length', 'pRight_Tm', 'pRight_GC', 'pRight_Sequences', 
                'pRight_EndStability', 'Penalty', 'Product_size', 'Amplicon_type']
                # 'Designed_ranges']
    df = pd.DataFrame(columns=columns)

    df['pLeft_ID'] = pLeft_ID
    df['pLeft_coord'] = pLeft_coord
    df['pLeft_length'] = pLeft_length
    df['pLeft_Sequences'] = pLeft_Sequences
    df['pRight_ID'] = pRight_ID
    df['pRight_coord'] = pRight_coord
    df['pRight_length'] = pRight_length
    df['pRight_Sequences'] = pRight_Sequences
    df['Product_size'] = Project_size
    # df['Designed_ranges'] = Designed_ranges
    df['pLeft_Tm'] = '-'
    df['pLeft_GC'] = '-'
    df['pLeft_EndStability'] = '-'
    df['pRight_Tm'] = '-'
    df['pRight_GC'] = '-'
    df['pRight_EndStability'] = '-'
    df['Penalty'] = '-'
    df['Amplicon_type'] = 'User-defined'


    primer_pool = pRight_Sequences + pLeft_Sequences
    # covered_ranges = [[locl, locr]]
    covered_ranges = []

    return df, primer_pool, full_data, covered_ranges
    # Create an empty DataFrame with these columns

def find_closest_number(target, numbers):
    # Calculate the absolute difference between the target and each number in the list
    closest_num = min(numbers, key=lambda x: abs(x - target))
    return closest_num

def quick_estimate_amplicons(df, amplicon_length, segmented=None):
    """
    Estimates the number of amplicons needed to cover given genomic positions.mplicons assigned for specific gene
    
    Parameters:
    - df: DataFrame with a 'genomic_pos' column representing genomic positions.
    - amplicon_length: The length of genomic positions that a single amplicon can cover.
    
    Returns:
    - The estimated number of amplicons needed.
    """
    amplicon_count = 0
    current_end = -1  # Initialize to a position before any possible genomic position
    
    if segmented != None: 
        # amplicon_sizes_l = np.arange(segmented[0], segmented[1]+1, segmented[2]).tolist()*segmented[3]
        used = []
        numbers = segmented.copy()
        numbers.sort()
        for gene in df['gene'].unique(): # for each gene
            sorted_positions = df[df['gene']==gene]['genome_pos'].sort_values().unique()
            sorted_positions_size = max(sorted_positions) - min(sorted_positions)
            # print('sorted_positions_size:', sorted_positions_size)
            target = sorted_positions_size
            min_combination = []
            # Initialize min_sum to a large value
            min_sum = float('inf')
            
            for r in range(1, len(numbers) + 1): 
                for combo in combinations(numbers, r): # look for the best combination of amplicon sizes that exceeds the gene target by the least amount
                    current_sum = sum(combo)
                    # print(current_sum, combo, r)
                    # If current sum exceeds target, check if it's the new minimum
                    if current_sum > target:
                        if current_sum < min_sum:
                            min_sum = current_sum
                            min_combination = combo
                        else:
                            # Early break if current_sum exceeds min_sum (because it will only increase)
                            break
                # Early stopping: if the smallest combination of length r exceeds the target, longer lengths will too
                if min_sum <= sum(numbers[:r]):
                    break
            # print('min_combination:', min_combination)
            used.extend(min_combination)
            for x in min_combination:
                numbers.remove(x)
                
        unused_ = {value: numbers.count(value) for value in set(numbers)}
        unused_ = dict(sorted(unused_.items(), reverse=True))
        used_ = {value: used.count(value) for value in set(used)}
        used_ = dict(sorted(used_.items(), reverse=True))
        
        return len(used), used_, unused_
        # Iterate through genomic positions
            # for pos in sorted_positions:
            #     # Check if current position is outside the range of the current amplicon
            #     if pos > current_end:
            #         # Start a new amplicon
            #         amplicon_count += 1
            #         current_end = pos + amplicon_sizes_l.pop(0) - 1  # Determine the new amplicon's end position
        
        unused_ = {value: amplicon_sizes_l.count(value) for value in set(amplicon_sizes_l)}
        unused_ = dict(sorted(unused_.items(), reverse=True))
        used_ = {value: used.count(value) for value in set(used)}
        used_ = dict(sorted(used_.items(), reverse=True))
        return amplicon_count, used_, unused_
    else:
        # Ensure the genomic positions are sorted
        # Initialize counters

        for gene in df['gene'].unique():
            sorted_positions = df[df['gene']==gene]['genome_pos'].sort_values().unique()
        
        # Iterate through genomic positions
            for pos in sorted_positions:
                # Check if current position is outside the range of the current amplicon
                if pos > current_end:
                    # Start a new amplicon
                    amplicon_count += 1
                    current_end = pos + amplicon_length - 1  # Determine the new amplicon's end position
                    
        return amplicon_count

def extract_gff3(gff3_file_path):
    # Read the GFF3 file
    gff3_columns = ['seqid', 'source', 'type', 'start', 'end', 'score', 'strand', 'phase', 'attributes']
    gff3_df = pd.read_csv(gff3_file_path, sep='\t', comment='#', names=gff3_columns)

    # Filter to keep only gene entries and explicitly create a copy
    genes_df = gff3_df[gff3_df['type'] == 'gene'].copy()

    # Extract gene names from the attributes column
    genes_df['gene_id'] = genes_df['attributes'].apply(lambda x: x.split(';')[0].split('=')[1].split(':')[1])
    genes_df['gene_name'] = genes_df['attributes'].apply(lambda x: x.split(';')[1].split('=')[1])

    # Create a new DataFrame with the required information
    genes_info_df = genes_df[['gene_id', 'gene_name', 'seqid', 'start', 'end']]

    # Rename columns for clarity
    genes_info_df.columns = ['gene_id', 'gene_name', 'chr', 'start', 'end']
    genes_info_df[genes_info_df['gene_name'] != 'protein_coding']
    return genes_info_df

def pop_first_item(d, a):
    if d:
        # Get the first key in the dictionary
        first_key = next(iter(d))
        
        if a<d[first_key]: # a is only inputed if 
            d.update({first_key: d[first_key]-a})
            return first_key, a
        # Remove and return the key-value pair
        return first_key, d.pop(first_key)
    else:
        raise KeyError('pop_first_item(): dictionary is empty')


def pop_first_item_simple(d):
    if d:
        # Get the first key in the dictionary
        first_key = next(iter(d))
        # Remove and return the key-value pair
        return first_key, d.pop(first_key)
    else:
        raise KeyError('pop_first_item(): dictionary is empty')


def main(args):
    print('>>>Designing Amplicons')
    #test run: python main.py design -s variants.csv -ref MTB-h37rv_asm19595v2-eg18.fa -op ../test -a 400 -p 200 -sn 0 -sg rpoB,katG,embB,pncA,rpsL,rrs,ethA,fabG1,gyrA,gid,inhA,ethR,rpoC,ahpC,gyrB,folC,tlyA,alr,embA,thyA,eis -nn 30 -g -sp -sp_f spacers.bed 
    #test run: python main.py design -op ../test -a 400 -sn 1 -sg rpoB,katG -nn 1
    #test run: python main.py design -op ../test -a 400 -sn  -sg rpoB,katG -nn 35 -sc
    # python main.py design -op ../test -a 400 -sn 1 -sg rpoB,katG -nn 1 -sc
    # python main.py design -op ../test -a 400 -sn 1 -sg rpoB,katG -nn 1 -sc
    # python main.py design -op ../test -a 1000 -sn 2 -sg rpoB,katG -nn 15 -sc
    # python main.py design -op ../test -a 400 -nn 0 -sc
    # Rationale:
    # This program is designed to perform primer design for PCR amplification,
    # taking into consideration various parameters such as amplicon size, SNP priority,
    # reference genome, and more. It also allows users to specify particular amplicons
    # based on gene names and offers graphical output options. Users can also choose to
    # include spoligotyping sequencing information. The program outputs results to a 
    # specified folder.
    start = time.time()

    # Displaying the User Settings for Verification:
    print("============= Design: User Settings =============")
    print(f"- Amplicon Size: {args.amplicon_size}")
    print(f"- SNP Priority: {args.snp_priority}")
    print(f"- Reference Genome: {args.reference_genome}")
    print(f"- gff file: {args.gff3_file}")
    print(f"- User defined primers: {args.user_defined_primers}")
    if args.padding_size == None:
        print(f"- Padding_size: {int(args.amplicon_size/6)}")
        # print(f"Padding_size: {args.amplicon_size/8}")
    else:
        print(f"- Padding_size: {args.padding_size}")
        
    if args.segmented_amplicon_size != None:
        print(f"- Segmented Amplicon Size [min, max, step, count of each step]: [{args.segmented_amplicon_size}]")
    if args.specific_amplicon_no != None:
        print(f"- Specific Amplicon Number: {args.specific_amplicon_no}")
    if args.specific_amplicon_gene != '':
        print(f"- Specific Amplicon Gene: {args.specific_amplicon_gene}")
    if args.segmented_amplicon_size != None:
        print(f"- Non-specific Amplicon Number: unused")
    else:
        print(f"- Non-specific Amplicon Number: {args.non_specific_amplicon_no}")
    print(f"- Amplicon search setting: {args.global_args}")
    print(f"- Graphic Option: {args.graphic_option}")
    print(f"- Spoligo Sequencing: {args.spoligo_coverage}")
    if args.spoligo_coverage:
        print(f"- Spoligo Sequencing File: {args.spoligo_sequencing_file}")
    print(f"- Output Folder Path: {args.output_folder_path}")
    print(f"- Mutiplex grouping: {args.multiplexing}")
    print("=================================================")

    gene_names = [
        "rpoB",
        "katG",
        "embB",
        "pncA",
        "rpsL",
        "rrs",
        "ethA",
        "fabG1",
        "gyrA",
        "gid",
        "inhA",
        "ethR",
        "rpoC",
        "ahpC",
        "gyrB",
        "folC",
        "tlyA",
        "alr",
        "embA",
        "thyA",
        "eis"
    ]
    global_args = args.global_args
    read_size = args.amplicon_size
    segmented = args.segmented_amplicon_size
    # full data - priority file with weights&frequency for each snp
    full_data= pd.read_csv(args.snp_priority)
    full_data = full_data[~full_data['drugs'].isna()]
    # full_gene = full_data[~full_data['type'].isin(['synonymous_variant','non_coding_transcript_exon_variant'])]
    full_data = full_data.sort_values(by=['genome_pos'])
    full_data = full_data.reset_index(drop=True)
    full_data['weight'] = full_data['freq']
    full_data.loc[full_data['gene'].isin(gene_names), 'weight'] += 0.5

    # paddding size
    if args.padding_size == None:    
        padding = int(read_size/6)
        # padding = int(read_size/2)
        # padding = 50
    else:
        padding = args.padding_size

    # Reference Genome
    ref_genome = args.reference_genome
    #specific_genes
    if args.specific_amplicon_gene:
        specific_gene = args.specific_amplicon_gene.split(',')
        specific_gene = [item.strip().lower() for item in specific_gene]
    else:
        specific_gene = []

    primer_input_file = args.user_defined_primers

    covered_positions, covered_ranges = [], []
    covered_positions_nosp, covered_ranges_nosp, covered_positions_sp, covered_ranges_sp  = {}, [], {}, []
    primer_pool, no_primer_ = [], []
    accepted_primers = pd.DataFrame(columns = ['pLeft_ID', 'pLeft_coord', 'pLeft_length', 'pLeft_Tm', 'pLeft_GC',
        'pLeft_Sequences', 'pLeft_EndStability', 'pRight_ID', 'pRight_coord',
        'pRight_length', 'pRight_Tm', 'pRight_GC', 'pRight_Sequences',
        'pRight_EndStability', 'Penalty', 'Product_size'])

    user_defined_no = 0
    if args.user_defined_primers != None:
        print('=====User defined amplicon file detected=====')
        accepted_primers, primer_pool, full_data, covered_ranges = user_defined(primer_input_file, ref_genome, full_data)
        user_defined_no = accepted_primers.shape[0]
    
    # print(accepted_primers)
    # non_specific_gene = []
    # specific_gene_amplicon
    specific_gene_amplicon = args.specific_amplicon_no
    # non_specific_amplicon
    non_specific_amplicon = args.non_specific_amplicon_no
    # this is way we separate the specific and non-specific amplicons
    # specific_gene_data = full_data[full_data['gene'].isin(specific_gene)]
    # non_specific_gene_data = full_data[~full_data['gene'].isin(specific_gene)]
    # this way we still have non specific amplicons incorporate the specific genes
    # specific_gene_data = full_data.copy()
    # Create the condition for rows where 'gene' value is not in specific_gene
    # condition = ~specific_gene_data['gene'].isin(specific_gene)
    # Update the 'weight' column in the new DataFrame where the condition is True
    # specific_gene_data.loc[condition, 'weight'] = 0
    non_specific_gene_data = full_data.copy()
    ref_size = wa.genome_size(ref_genome)
    specific_gene_data_count = 0
    #main output folder path
    output_path = args.output_folder_path

    # Calculating number of amplicon needed
    # target_coverage = 1
    # gene_coverage = Amplicon_no.place_amplicon_search(full_data, target_coverage, read_size, genome_size(ref_genome))
    if args.segmented_amplicon_size != None:
        segmented = args.segmented_amplicon_size     
        segmented = segmented.strip().split(',')
        segmented = [int(i.strip()) for i in segmented]
        amplicon_sizes_l = np.arange(segmented[0], segmented[1]+1, segmented[2]).tolist()*segmented[3]
        # amplicon_sizes.sort(reverse=True)
        # read_size = amplicon_sizes[0] # use max amplicon size
        amplicon_sizes = {value: amplicon_sizes_l.count(value) for value in set(amplicon_sizes_l)}
        amplicon_sizes = dict(sorted(amplicon_sizes.items(), reverse=True))
        print('==Segmented amplicon size:', amplicon_sizes)
        
    gff_df = extract_gff3(args.gff3_file)
    if len(specific_gene)>0:
        print('=====Specific amplicon=====')
        # gff_df_lower = gff_df.applymap(lambda x: x.lower() if isinstance(x, str) else x)
        gff_df_lower = gff_df.copy()
        for col in gff_df_lower.columns:
            if gff_df_lower[col].dtype == 'object':  # Check if the column is of type 'object' (string-like)
                gff_df_lower[col] = gff_df_lower[col].str.lower()  # Convert the entire column to lowercase

        for x in specific_gene:
            # with np.printoptions(threshold=np.inf):
                # print(gff_df['gene_id'].unique())
            if (x not in gff_df_lower['gene_name'].tolist()) and (x not in gff_df_lower['gene_id'].tolist()):
                raise Exception(f'>> *{x}* is not a valid gene name/id >> Try using gene id/name instead')
        df1 = gff_df_lower[gff_df_lower['gene_id'].isin(specific_gene) | gff_df_lower['gene_name'].isin(specific_gene)]#[['start','end']]
        all_positions = []
        # Iterate through each range and generate positions
        for i, row in df1.iterrows():
            # Generate positions for the current range and append to the list
            all_positions.extend(range(row.start, row.end + 1))  # end + 1 because range is exclusive at the end
        # Create a DataFrame
        specific_gene_data = pd.DataFrame({
            'genome_pos': all_positions,
            'weight': 1.0,
            'freq': 1.0
        })
        
        gene_names = []
        changes = []
        drugs = []
        sublins = []
        dr_types = []
        for x in all_positions:
            for i, row in df1.iterrows():
                if x in range(row.start, row.end + 1):
                    gene_names.append(row['gene_id'])
            if x in full_data['genome_pos'].tolist():
                # gene_names.append(full_data[full_data['genome_pos'] == x]['gene'].values[0])
                changes.append(full_data[full_data['genome_pos'] == x]['change'].values[0])
                drugs.append(full_data[full_data['genome_pos'] == x]['drugs'].values[0])
                sublins.append(full_data[full_data['genome_pos'] == x]['sublin'].values[0])
                dr_types.append(full_data[full_data['genome_pos'] == x]['drtype'].values[0])
            else:
                # gene_names.append(gff_df[(gff_df['start'] <= x) & (gff_df['end'] >= x)]['gene_name'].tolist()[0])
                changes.append('-')
                drugs.append('-')
                sublins.append('-')
                dr_types.append('-')                
        
        specific_gene_data['gene'] = gene_names
        specific_gene_data['change'] = changes
        specific_gene_data['drugs'] = drugs
        specific_gene_data['sublin'] = sublins
        specific_gene_data['drtype'] = dr_types
        
        specific_gene_data = specific_gene_data.sort_values(by='genome_pos', ascending=True)

        if specific_gene_amplicon == None:
            if segmented:
                specific_gene_amplicon, used, unused = quick_estimate_amplicons(specific_gene_data, read_size, amplicon_sizes_l)
            else:
                specific_gene_amplicon = quick_estimate_amplicons(specific_gene_data, read_size)
        # def place_amplicon(full_data, read_number, read_size, primer_pool, accepted_primers, no_primer_, ref_genome, graphic_output=False, padding=150, output_path = '.'):
            # if segmented:
            if specific_gene_amplicon > len(amplicon_sizes_l):
                raise Exception(f'!! The number of specific amplicons needed - {specific_gene_amplicon} is more than the number of amplicon sizes specified, consider increasing the number of amplicon sizes or reducing the number of specific amplicons')
            print(f'> {specific_gene_amplicon} amplicons assigned for specific gene {specific_gene} coverage')
        if segmented:
            print('>', used)
            # for x in range (specific_gene_amplicon+1): #add one specific gene amplicon
            #     read_size, read_num = pop_first_item(amplicon_sizes)
            #     covered_positions_sp, covered_ranges_sp, specific_gene_data, primer_pool, accepted_primers, no_primer_ = wa.place_amplicon(specific_gene_data, read_num, read_size, primer_pool, accepted_primers, no_primer_, ref_genome, global_args, args.graphic_option, padding=padding, output_path=output_path)
            #     covered_positions = covered_positions + covered_positions_sp
            for gene in specific_gene_data['gene'].unique(): # for each gene

                specific_gene_data_sub = specific_gene_data[specific_gene_data['gene']==gene]
                specific_gene_amplicon, used, unused = quick_estimate_amplicons(specific_gene_data_sub, read_size, amplicon_sizes_l)
                amplicon_sizes_l = [num for num, count in unused.items() for _ in range(count)]


                while specific_gene_amplicon > 0:
                    read_size, read_num = pop_first_item(used, specific_gene_amplicon)
                    if read_num < specific_gene_amplicon:
                        specific_gene_amplicon -= read_num
                        covered_positions_sp_, covered_ranges_sp_, specific_gene_data, primer_pool, accepted_primers, no_primer_ = wa.place_amplicon(specific_gene_data, read_num, read_size, primer_pool, accepted_primers, no_primer_, ref_genome, global_args, args.graphic_option, padding=padding, output_path =output_path)
                        covered_positions_sp =  {**covered_positions_sp, **covered_positions_sp_}
                        covered_ranges_sp = covered_ranges_sp + covered_ranges_sp_
                    else:
                        read_num = specific_gene_amplicon
                        covered_positions_sp_, covered_ranges_sp_, specific_gene_data, primer_pool, accepted_primers, no_primer_ = wa.place_amplicon(specific_gene_data, read_num, read_size, primer_pool, accepted_primers, no_primer_, ref_genome, global_args, args.graphic_option, padding=padding, output_path =output_path)
                        covered_positions_sp =  {**covered_positions_sp, **covered_positions_sp_}
                        covered_ranges_sp = covered_ranges_sp + covered_ranges_sp_
                        specific_gene_amplicon = 0
        
        else:
            covered_positions_sp, covered_ranges_sp, specific_gene_data, primer_pool, accepted_primers, no_primer_ = wa.place_amplicon(specific_gene_data, specific_gene_amplicon, read_size, primer_pool, accepted_primers, no_primer_, ref_genome, global_args, args.graphic_option, padding=padding, output_path=output_path)
        specific_gene_data_count = accepted_primers.shape[0] - user_defined_no 

        if non_specific_amplicon > 0:
            print('=====Non-specific amplicon=====')
            
            for (x, y) in covered_ranges_sp:         # below code is to add specific gene changed weights onto full data
                condition = (non_specific_gene_data['genome_pos'] >= x) & (non_specific_gene_data['genome_pos'] <= y)
                non_specific_gene_data.loc[condition, 'weight'] = 0

            # non_specific_gene_data.update(specific_gene_data) # add the specific gene data to the non-specific gene data
            if segmented:
                amplicon_sizes = unused
                if len(amplicon_sizes) == 0:
                    print('!! No more amplicon to use for non-specific gene coverage, all has been used up for specific gene coverage, consider increasing the number of amplicon')    
                # for x in range (specific_gene_amplicon+1): #add one specific gene amplicon
                for x in range(len(amplicon_sizes)):
                    read_size, read_num = pop_first_item_simple(amplicon_sizes)
                    covered_positions_nosp_, covered_ranges_nosp_, non_specific_gene_data, primer_pool, accepted_primers, no_primer_ = wa.place_amplicon(non_specific_gene_data, read_num, read_size, primer_pool, accepted_primers, no_primer_, ref_genome, global_args, args.graphic_option, padding=padding, output_path =output_path)
                    covered_positions_nosp =  {**covered_positions_nosp, **covered_positions_nosp_}
                    covered_ranges_nosp = covered_ranges_nosp + covered_ranges_nosp_
            else:
                covered_positions_nosp, covered_ranges_nosp, non_specific_gene_data, primer_pool, accepted_primers, no_primer_ = wa.place_amplicon(non_specific_gene_data, non_specific_amplicon, read_size, primer_pool, accepted_primers, no_primer_, ref_genome, global_args, args.graphic_option, padding=padding, output_path =output_path)
            
            covered_positions = {**covered_positions_sp, **covered_positions_nosp}
        
            covered_ranges = covered_ranges + covered_ranges_sp + covered_ranges_nosp
            non_specific_gene_data_count = accepted_primers.shape[0] - user_defined_no - specific_gene_data_count
        else:
            non_specific_gene_data_count = 0
            covered_positions = covered_positions_sp
            covered_ranges = covered_ranges_sp

    else:
        if args.non_specific_amplicon_no > 0:
            print('=====Non-specific amplicon=====')
            if segmented:
                # print('Designing Segmented Amplicons')
                # for x in range (specific_gene_amplicon+1): #add one specific gene amplicon
                #     read_size, read_num = pop_first_item(amplicon_sizes)
                #     covered_positions_nosp_, covered_ranges_nosp, full_data_cp, primer_pool, accepted_primers, no_primer_ = wa.place_amplicon(non_specific_gene_data, read_num, read_size, primer_pool, accepted_primers, no_primer_, ref_genome, global_args, args.graphic_option, padding=padding, output_path =output_path)
                #     covered_positions_nosp = covered_positions_nosp + covered_positions_nosp_
                #     covered_ranges = covered_ranges + covered_ranges_nosp
                # non_specific_gene_data_count = accepted_primers.shape[0] - user_defined_no
                
                for x in range(len(amplicon_sizes)): # this loop is only needed for segmented amplicons
                    read_size, read_num = pop_first_item_simple(amplicon_sizes)
                    # covered_positions_nosp_, covered_ranges_nosp_, full_data_cp, primer_pool, accepted_primers, no_primer_ = wa.place_amplicon(non_specific_gene_data, read_num, read_size, primer_pool, accepted_primers, no_primer_, ref_genome, global_args, args.graphic_option, padding=padding, output_path =output_path)
                    covered_positions_nosp_, covered_ranges_nosp_, non_specific_gene_data, primer_pool, accepted_primers, no_primer_ = wa.place_amplicon(non_specific_gene_data, read_num, read_size, primer_pool, accepted_primers, no_primer_, ref_genome, global_args, args.graphic_option, padding=padding, output_path =output_path)
                    # print('!!!')
                    # print(full_data_cp)
                    # print(non_specific_gene_data)
                    covered_positions_nosp =  {**covered_positions_nosp, **covered_positions_nosp_}

                    # covered_positions_nosp = covered_positions_nosp + covered_positions_nosp_
                    covered_ranges_nosp = covered_ranges_nosp + covered_ranges_nosp_
      
            else:
                covered_positions_nosp, covered_ranges_nosp, full_data_cp, primer_pool, accepted_primers, no_primer_ = wa.place_amplicon(non_specific_gene_data, non_specific_amplicon, read_size, primer_pool, accepted_primers, no_primer_,ref_genome, global_args, args.graphic_option, padding=padding, output_path =output_path)
                covered_positions = covered_positions_nosp
            covered_ranges = covered_ranges + covered_ranges_nosp
            non_specific_gene_data_count = accepted_primers.shape[0] - user_defined_no
        else:
            non_specific_gene_data_count = 0
            pass
        
    # whether or not you wanna include spoligotyping sequencing
    spoligotype = args.spoligo_coverage
    covered_ranges_spol = []
    # if spoligotype:            

    # get the amplicon numbers in order:

    #     print('=====Spoligotype amplicon=====')

    #     spacers = pd.read_csv(args.spoligo_sequencing_file, sep='\t', header=None)
    #     spacers = np.array(spacers)
    #     spacers = spacers[:, 1:3]
    #     spacers = spacers.tolist()
    #     flattened_data = [item for sublist in spacers for item in sublist]
    #     spacer_max = max(flattened_data)
    #     spacer_min = min(flattened_data)
    #     spol_list = np.arange(spacer_min-400,spacer_max+400,1)
    #     weight = [0.01]*len(spol_list) 
    #     spol_data = pd.DataFrame({'genome_pos':spol_list,'weight':weight})
    #     # Create a list of boolean masks, one for each range
    #     masks = [(spol_data['genome_pos'] >= start) & (spol_data['genome_pos'] <= end) for start, end in spacers]
    #     # Use reduce and the | operator to combine the masks into a single mask
    #     combined_mask = reduce(lambda x, y: x | y, masks)
    #     # Use .loc and the combined mask to update the weight column
    #     spol_data.loc[combined_mask, 'weight'] = 1
    #     covered_positions_spol, covered_ranges_spol, full_data_cp, primer_pool, accepted_primers, no_primer_ = Amplicon_no.place_amplicon_spol(spol_data, 1, read_size, ref_genome, primer_pool, accepted_primers, no_primer_, padding=padding, graphic_output=False, check_snp=False)
    #     covered_ranges = covered_ranges + covered_ranges_spol
    #     # print(covered_ranges)
    #     # print(covered_ranges_spol)
    #     # covered_ranges_spol = Amplicon_no.
    # 
    #(spol_data, 1, read_size, graphic_output=False, ref_size = wa.genome_size(ref_genome))
    #     # covered_ranges.extend(covered_ranges_spol)

    read_number = user_defined_no + specific_gene_data_count + non_specific_gene_data_count + len(covered_ranges_spol)
    # output
    primer_label = [f'Gene_specific:{args.specific_amplicon_gene}']*specific_gene_data_count + ['Non_specific']*non_specific_gene_data_count + ['Spoligotype']*len(covered_ranges_spol)
    # print(primer_label)
    # print(len(primer_label))
    # print(accepted_primers)
    # print(accepted_primers.shape)
    # print(covered_ranges)
    # print(no_primer_)
    # print(covered_ranges)
    # print(accepted_primers)
    # print(no_primer_)
    if 'Amplicon_type' in accepted_primers.columns:   
        cleaned_list = accepted_primers['Amplicon_type'].tolist()[:user_defined_no]
        primer_label = cleaned_list + primer_label

    accepted_primers['Amplicon_type'] = primer_label
    no_primer_ = ['-']*user_defined_no + no_primer_
    accepted_primers['Redesign'] = no_primer_
    accepted_primers['Designed_ranges'] = ['-']*user_defined_no + covered_ranges
    accepted_primers.reset_index(inplace = True)
    
    
    #accepted_primers - change primer to iupac
    threshold = 0.001
    all_snps = pd.read_csv(args.all_snps, sep = '\t', header = None)
    all_snps.drop_duplicates(inplace=True)
    accepted_primers = accepted_primers[accepted_primers['pLeft_Sequences'] != 0]
    for i, row in accepted_primers.iterrows():
        # print(row['pLeft_Sequences'])
        # print(row['pRight_Sequences'])
        #left primer
        primer_seq = ''
        # print('!!', row['pLeft_Sequences'])
        for x,y in zip(range(row['pLeft_coord'], row['pLeft_coord']+len(row['pLeft_Sequences'])), row['pLeft_Sequences']):
            if (all_snps[all_snps[0] == x][[1,2]].shape[0] > 0) and (all_snps[all_snps[0] == x][[3]].values.astype('float').item()>= threshold):
                alleles = ''.join(all_snps[all_snps[0] == x][[1,2]].values[0])
                primer_seq = primer_seq+wa.nucleotide_to_iupac(alleles)
            else:
                primer_seq = primer_seq+y
        if row['pLeft_Sequences'] != primer_seq:
            # print('SNP in the Left primer')
            accepted_primers.loc[i, 'pLeft_Sequences'] = primer_seq
        
        #right primer
        primer_seq = ''
        for x,y in zip(range(row['pRight_coord'], row['pRight_coord']+len(row['pRight_Sequences'])), primer_selection.reverse_complement_sequence(row['pRight_Sequences'])):
            if all_snps[all_snps[0] == x][[1,2]].shape[0] > 0 and all_snps[all_snps[0] == x][[3]].values.astype('float').item()>= threshold:
                alleles = ''.join(all_snps[all_snps[0] == x][[1,2]].values[0])
                primer_seq = primer_seq+wa.nucleotide_to_iupac(alleles)
            else:
                primer_seq = primer_seq+y
        # print(primer_seq)
        if row['pRight_Sequences'] != primer_seq:
            # print('SNP in the Right primer')
            accepted_primers.loc[i, 'pRight_Sequences'] = primer_selection.reverse_complement_sequence(primer_seq)
    
    # print(accepted_primers[['pLeft_Sequences','pRight_Sequences','pLeft_coord']].head(2))
    if spoligotype: # if spoligotype is included change labelling in output
        sp = '-sp'
    else:
        sp = ''
        
    # # Apply modifications
    for index, row in accepted_primers.iterrows():
        if row['Amplicon_type'] == 'User-defined':
            continue
        else:            
            accepted_primers.at[index, 'pLeft_ID'] = wa.modify_primer_name(row['pLeft_ID'], row['Amplicon_type'], 'L')
    for index, row in accepted_primers.iterrows():
        if row['Amplicon_type'] == 'User-defined':
            continue
        else:
            accepted_primers.at[index, 'pRight_ID'] = wa.modify_primer_name(row['pRight_ID'], row['Amplicon_type'], 'R')    
            
    # Amplicon_id  = []
    # # Extract the part after '-' from 'pLeft_ID' for use in both new columns
    # split_part = accepted_primers['pLeft_ID'].str.split('-').str[:-1]
    # split_part = split_part.str.join('-').replace('UserLeft', 'UserAmplicon', regex=True)

    # # Generate index-based part ('A1', 'A2', ...) and add 1 because Python uses 0-based indexing
    # index_part = 'A' + (accepted_primers.index + 1).astype(str)
    # # Combine the parts to form 'designed_range_name' and 'amplicone_name'
    # accepted_primers.insert(1, 'Amplicon_ID', index_part + '-' + split_part)
    
    amplicone_name_list = []
    for i, x in accepted_primers.iterrows():
        # designed_range_name = f"Designed-A{i+1}-{x['pLeft_ID'].split('-')[1]}
        if 'User' not in x['pLeft_ID']:
            # designed_range_name = f"Designed-A{i+1-user_defined_no}-{x['pLeft_ID'].split('-')[1]}"
            match = re.search("P(\d+)", x['pLeft_ID'])
            number_after_p = int(match.group(1)) if match else None

            amplicone_name = f"A{number_after_p}-{x['pLeft_ID'].split('-')[1]}"
        else:
            # amplicone_name = f"A-{x['pLeft_ID'].split('-')[0]}-{x['pLeft_ID'].split('-')[1]}"
            amplicone_name = f"A-{x['pLeft_ID'].split('-')[0]}-UserAmplicon"
            
            # amplicone_name = amplicone_name.replace('UserLeft', 'UserAmplicon')
            
        amplicone_name_list.append(amplicone_name)

    accepted_primers.insert(1, 'Amplicon_ID', amplicone_name_list)
    # print('before increment')
    # print(accepted_primers)
    
    # if segmented:
        # def increment_id_with_regex(df, col_name):
        #     counter = {}  # Track counts of each ID
        #     new_ids = []  # Store updated IDs

        #     for id in df[col_name]:
        #         original_id = id
        #         # Use regex to find all numbers in the ID
        #         numbers = re.findall(r'\d+', id)
        #         if numbers:
        #             last_number = numbers[-1]  # Focus on the last number found
        #             new_id = id
        #             while new_id in counter:
        #                 # Increment the last number found
        #                 new_number = str(int(last_number) + 1)
        #                 # Replace the last occurrence of the number with its incremented value
        #                 new_id = re.sub(r'(?<!\d)'+last_number+r'(?!\d)', new_number, new_id, count=1)
        #                 last_number = new_number  # Update last_number for potential next iteration

        #             counter[new_id] = True  # Mark this new ID as seen
        #             new_ids.append(new_id)  # Add to the list of new IDs
        #         else:
        #             # If no number is found, just append the ID as is
        #             new_ids.append(id)

        #         # Update counter for the original ID if it's not already there to handle non-duplicates correctly
        #         if original_id not in counter:
        #             counter[original_id] = True

        #     df[col_name] = new_ids  # Update the column with new IDs

    def increment_id_with_regex(df, col_name):
        counter = {}  # Track counts of each ID
        new_ids = []  # Store updated IDs

        for id in df[col_name]:
            # original_id = id
            # Use regex to find all numbers in the ID
            if 'User' in id:
                continue
            numbers = re.findall(r'\d+', id)

            if numbers:
                first_number = numbers[0]  # Focus on the first number found
                if len(id.split('-')) > 2:
                    check_id = '-'.join(id.split('-')[:-1])
                else:
                    check_id = id
                new_id = id
                while check_id in counter:                
                    # Increment the first number found
                    new_number = str(int(first_number) + 1)
                    # Replace the first occurrence of the number with its incremented value
                    new_id = re.sub(r'(?<!\d)'+first_number+r'(?!\d)', new_number, new_id, count=1)
                    check_id = re.sub(r'(?<!\d)'+first_number+r'(?!\d)', new_number, check_id, count=1)
                    first_number = new_number  # Update first_number for potential next iteration
                counter[check_id] = True  # Mark this new ID as seen
                new_ids.append(new_id)  # Add to the list of new IDs
            # else:
            #     # If no number is found, just append the ID as is
            #     new_ids.append(id)

            # Update counter for the original ID if it's not already there to handle non-duplicates correctly
            # if original_id not in counter:
            #     counter[original_id] = True

        df[col_name] = new_ids  # Update the column with new IDs

    increment_id_with_regex(accepted_primers,'Amplicon_ID')
    increment_id_with_regex(accepted_primers, 'pLeft_ID')
    increment_id_with_regex(accepted_primers, 'pRight_ID')


    # accepted_primers['pLeft_ID'] = accepted_primers.apply(lambda x: wa.modify_primer_name(x['pLeft_ID'], x['Amplicon_type'], 'L'), axis=1)
    # accepted_primers['pRight_ID'] = accepted_primers.apply(lambda x: wa.modify_primer_name(x['pRight_ID'], x['Amplicon_type'], 'R'), axis=1)
    if segmented:
        
        read_size = '_'.join(str(x) for x in segmented)
    
    def len_calc(l):
        # coords = [int(x.replace('[', '').replace(']', '')) for x in l.split(',')]
        coords = l
        return coords[1] - coords[0]

    accepted_primers['Designed_size'] =  list(map(len_calc, accepted_primers['Designed_ranges']))
    
    # GETTING MULTIPLEX GROUPING
    if args.multiplexing:
        primers_df = accepted_primers.copy()
        # Sort the DataFrame by location
        primers_df = primers_df.sort_values(by='pLeft_coord').reset_index(drop=True)
        # Initialize variables
        multiplex_groups = []
        group_ind_list = []

        def can_add_to_group(primer, group, range_size=1000, product_range=50):
            # Check location constraint
            if any(abs(primer['pLeft_coord'] - p['pLeft_coord']) < range_size for p in group):
                return False
            # Check product size constraint
            if any(abs(primer['Product_size'] - p['Product_size']) < product_range for p in group):
                return False
            return True

        # Iterate over the primers and assign them to groups
        for idx, primer in primers_df.iterrows():
            added_to_group = False
            for group_idx, group in enumerate(multiplex_groups):
                if can_add_to_group(primer, group):
                    multiplex_groups[group_idx].append(primer)
                    group_ind_list.append(group_idx + 1)
                    added_to_group = True
                    break
            if not added_to_group:
                multiplex_groups.append([primer])
                group_ind_list.append(len(multiplex_groups))

        _ = primers_df[['Amplicon_ID']].copy()
        _.loc[:,'Group'] = group_ind_list
        _.loc[:,'Amplicon_ID'] = pd.Categorical(_['Amplicon_ID'], categories=accepted_primers['Amplicon_ID'].tolist(), ordered=True)
        # Sort the DataFrame by the 'Name' column
        _sorted = _.sort_values('Amplicon_ID')
        # Reset index if needed
        _sorted = _sorted.reset_index(drop=True)
        merged_df = pd.merge(accepted_primers, _, on='Amplicon_ID')
        accepted_primers = merged_df.copy()
    
    op = f'{output_path}/Amplicon_design_output'
    os.makedirs(op, exist_ok=True) #output path
    accepted_primers.drop(columns=['index'], inplace=True)
    # accepted_primers.to_csv(f'{op}/Primer_design-accepted_primers-{read_number}-{read_size}{sp}.csv',index=False)

    # primer_pos = accepted_primers[['pLeft_coord','pRight_coord']].values
    # columns = ['pLeft_ID', 'pRight_ID', 'pLeft_coord', 'pRight_coord', 'SNP_inclusion']

    # # Create an empty DataFrame with the specified column headings
    # primer_inclusion = pd.DataFrame(columns=columns)
    # for i, row in accepted_primers.iterrows():
    #     data = full_data[(full_data['genome_pos']>= row['pLeft_coord']) & (full_data['genome_pos']<= row['pRight_coord'])]    
    #     info = row[['pLeft_ID', 'pRight_ID', 'pLeft_coord', 'pRight_coord']]
    #     SNP = data['gene'].str.cat(data['change'], sep='-').unique()
        
    #     info['SNP_inclusion'] = ','.join(SNP)
    #     primer_inclusion.loc[len(primer_inclusion)] = info.tolist()
    
    # columns = ['SNP', 'Genomic_pos', 'Amplicon_ID']
    # snp_list = []
    # amplicon_id_list = []
    # pos_list = []
    # primer_inclusion = pd.DataFrame(columns=columns)
    # for i, row in full_data.iterrows():
    #     snp = row['gene'] + '-' + row['change']
    #     pos = row['genome_pos']
    #     amplicon_id = []
    #     for w, roww in accepted_primers.iterrows():
    #         if pos >= roww['pLeft_coord'] and pos <= roww['pRight_coord']:
    #             amplicon_id.append(roww['Amplicon_ID'])
        
    #     if len(amplicon_id) > 0:
    #         amplicon_id_list.append(','.join(amplicon_id))
    #     else:
    #         amplicon_id_list.append('-')
    
    #     snp_list.append(snp)
    #     pos_list.append(pos)
    # primer_inclusion['SNP'] = snp_list
    # primer_inclusion['Genomic_pos'] = pos_list
    # primer_inclusion['Amplicon_ID'] = amplicon_id_list

    # Function to find matching amplicon IDs for each row in full_data
    def find_amplicon_ids(row):
        pos = row['genome_pos']
        matching_amplicons = accepted_primers[(accepted_primers['pLeft_coord'] <= pos) & 
                                            (accepted_primers['pRight_coord'] >= pos)]['Amplicon_ID']
        return ','.join(matching_amplicons) if not matching_amplicons.empty else '-'
    unique_rows = full_data.drop_duplicates(subset=['gene', 'change'])

    # Apply the function to each row in full_data to generate a Series of amplicon IDs
    amplicon_id_series = unique_rows.apply(find_amplicon_ids, axis=1)

    # Create 'snp' Series directly using vectorized operations
    snp_series = unique_rows['gene'] + '-' + unique_rows['change']

    # Construct the final DataFrame
    primer_inclusion = pd.DataFrame({
        'SNP': snp_series,
        'Genomic_pos': unique_rows['genome_pos'],
        'Amplicon_ID': amplicon_id_series
    })

    primer_inclusion.to_csv(f'{op}/Mutation_inclusion-{read_number}-{read_size}.csv',index=False, lineterminator=None)

    df1 = primer_inclusion['Amplicon_ID'].value_counts().to_frame()
    df1.insert(0, 'Amplicon_id', df1.index)
    df1.columns = ["Amplicon_ID", "Num_SNP_covered"]

    df1.to_csv(f'{op}/Amplicon_importance-{read_number}-{read_size}.csv',index=False)

    # if specific_gene_amplicon>0 or non_specific_amplicon>0:
    if specific_gene_amplicon is not None  or non_specific_amplicon is not None:
        # amp_snp = pd.DataFrame(columns=full_data.columns)
        
        dtypes = {}
    # Iterate over each column in the DataFrame
        for column in full_data.columns:
            # Get the data type of the column
            dtype = str(full_data[column].dtype)
            # Add the column and its data type to the dictionary
            dtypes[column] = dtype
        full_data_ = full_data.copy()
        full_data_.drop_duplicates(subset='change', inplace=True)
        amp_snp = pd.DataFrame(columns=dtypes.keys()).astype(dtypes)

        _len = accepted_primers[accepted_primers['Amplicon_type']!= 'Spoligotype'].shape[0]
        if _len == 0:
            pass
        else:
            # for (x,y) in covered_ranges[:_len]:
            for x,y in zip(accepted_primers['pLeft_coord'].tolist(), accepted_primers['pRight_coord'].tolist()):
                condition = (full_data_['genome_pos'] >= x) & (full_data_['genome_pos'] <= y)
                filtered_data = full_data_[condition]
                # Drop columns that are completely empty or all NA from filtered_data
                filtered_data = filtered_data.dropna(axis=1, how='all')
                amp_snp = pd.concat([amp_snp, filtered_data])
            
            amp_snp = amp_snp.drop_duplicates()
            
            full_data_gene = full_data_['gene'].value_counts()
            amp_snp_aligned = amp_snp['gene'].value_counts().reindex(full_data_gene.index).fillna(0)

            # Calculate the ratio and format as string
            result = amp_snp_aligned / full_data_gene
            formatted_result = result.apply(lambda x: f"{x:.0%}")

            # Combine the two series
            combined_series = amp_snp_aligned.astype(str) + "/" + full_data_gene.astype(str) + " (" + formatted_result + ")"
            # print(combined_series)
            # gene_coverage = round(amp_snp['gene'].value_counts()/full_data['gene'].value_counts()*100, 1)

            gene_coverage_df = combined_series.reset_index().fillna(0)
            gene_coverage_df.columns = ['Gene', 'SNP_coverage']
            print(tabulate(gene_coverage_df, headers='keys', tablefmt='grid'))
    
    if accepted_primers.shape[0] == 0:
        raise Exception('No primers designed')

    # for i, x in accepted_primers.iterrows():
    #     # designed_range_name = f"Designed-A{i+1}-{x['pLeft_ID'].split('-')[1]}
    #     if 'User' not in x['pLeft_ID']:
    #         # designed_range_name = f"Designed-A{i+1-user_defined_no}-{x['pLeft_ID'].split('-')[1]}"
    #         amplicone_name = f"A{i+1-user_defined_no}-{x['pLeft_ID'].split('-')[1]}"
    #         designed_range_name = f"Designed-A{i+1}-{x['pLeft_ID'].split('-')[1]}"
    #     else:
    #         amplicone_name = f"A-{x['pLeft_ID'].split('-')[0]}-{x['pLeft_ID'].split('-')[1]}"
    #         amplicone_name = amplicone_name.replace('UserLeft', 'UserAmplicon')

    
    out_bed = {}
    colors = ['0,0,255', '0,255,0', '255,0,0', '128,0,0']*(accepted_primers.shape[0]-user_defined_no) # defined colors for designed amplicons
    # print('user_defined_no:', user_defined_no)
    # print('accepted_primers.shape[0]:', accepted_primers.shape[0])
    # print(accepted_primers)
    colors = ['0,255,0',  '255,0,0', '128,0,0']*user_defined_no+colors # adding coloration for designed amplicons after user defined amplions
    # for i, x in accepted_primers.iterrows():
    #     designed_range_name = f"Designed-A{i+1}-{x['pLeft_ID'].split('-')[1]}"
    #     amplicone_name = f"A{i+1}-{x['pLeft_ID'].split('-')[1]}"
    #     amplicone_name = amplicone_name.replace('UserLeft', 'UserAmplicon')
    #     if 'User' not in designed_range_name:
    #         designed_range_name = f"Designed-A{i+1-user_defined_no}-{x['pLeft_ID'].split('-')[1]}"
    #         amplicone_name = f"A{i+1-user_defined_no}-{x['pLeft_ID'].split('-')[1]}"
            
    for i, x in accepted_primers.iterrows():
        # print(x['pLeft_ID'])
        # designed_range_name = f"Designed-A{i+1}-{x['pLeft_ID'].split('-')[1]}
        if 'User' not in x['pLeft_ID']:
            match = re.search("P(\d+)", x['pLeft_ID'])
            number_after_p = int(match.group(1)) if match else None
            # designed_range_name = f"Designed-A{i+1-user_defined_no}-{x['pLeft_ID'].split('-')[1]}"
            amplicone_name = f"A{number_after_p}-{x['pLeft_ID'].split('-')[1]}"
            designed_range_name = f"Designed-A{number_after_p}-{x['pLeft_ID'].split('-')[1]}"
            out_bed[designed_range_name] = x['Designed_ranges']
        else:
            # amplicone_name = f"A-{x['pLeft_ID'].split('-')[0]}-{x['pLeft_ID'].split('-')[1]}"
            amplicone_name = f"A-{x['pLeft_ID'].split('-')[0]}-UserAmplicon"
            # amplicone_name = amplicone_name.replace('UserLeft', 'UserAmplicon')
        # out_bed[amplicone_name] = [x['pLeft_coord'], x['pRight_coord']+x['pRight_length']]
        out_bed[amplicone_name] = [x['pLeft_coord'], x['pRight_coord']]
        out_bed[x['pLeft_ID']] = [x['pLeft_coord'], x['pLeft_coord']+x['pLeft_length']]
        out_bed[x['pRight_ID']] = [x['pRight_coord']-x['pRight_length'], x['pRight_coord']]

    out = pd.DataFrame(out_bed).T
    out[2] = out.index
    out.insert(loc = 0,
            column='col1',
            value = ['Chromosome'] * out.shape[0])
    # putting in the coluns
    out[4] = 0 # score 
    out[5] = '.' # strand
    out[6] = out[0] # thickStart
    out[7] = out[1] #ThickEnd
    # print(out)
    # print(colors)
    out[8] = colors # itemRgb
    out.columns = ['col0', 'col1', 'col2', 'col3', 'col4', 'col5', 'col6', 'col7', 'col8']
    condition = ~((out['col3'].str.contains('Designed')) & (out['col3'].str.contains('User')))
    out = out[condition]
    # print(out)
    
    if spoligotype:
        print('=====Spoligotype amplicon=====')
        print('Appending spoligotype primers...')
        db = '/'.join(__file__.split('/')[:-1]) + '/db'
        spol_p = pd.read_csv(f'{db}/spoligo_primer.bed', sep='\t', header=None)
        spol_p.columns = columns = ['col0', 'col1', 'col2', 'col3', 'col4', 'col5', 'col6', 'col7', 'col8']
        out = pd.concat([out, spol_p])
    
    out.to_csv(f'{op}/Amplicon_mapped-{read_number}-{read_size}.bed', sep='\t', header=False, index=False, lineterminator=None)
    
    #adding gene name in front of amplicon id
    gene_ = []

    for i, row in accepted_primers.iterrows():
        _ = False
        _ = gff_df[gff_df['start'] < row['pRight_coord']]
        _ = _[_['end'] > row['pLeft_coord']].iloc[:1]
        if _.shape[0]>0:
            gene_.append(_['gene_name'].values[0])
        else:
            gene_.append('_')
            
    accepted_primers['Amplicon_ID'] = [str(g) + '-' + str(a) for g, a in zip(gene_, accepted_primers['Amplicon_ID'])]

    accepted_primers.to_csv(f'{op}/Primer_design-accepted_primers-{read_number}-{read_size}{sp}.csv',index=False, lineterminator=None)

    print('-'*37)
    print('Primer design output files produced:')
    print(f'{op}/Mutation_inclusion-{read_number}-{read_size}.csv')
    print(f'{op}/Primer_design-accepted_primers-{read_number}-{read_size}.csv')
    print(f'{op}/Amplicon_mapped-{read_number}-{read_size}.bed')
    print(f'{op}/Amplicon_importance-{read_number}-{read_size}.csv')
    print(f'{op}/Gene_coverage-{read_number}-{read_size}.csv')
    
    gene_coverage_df.to_csv(f'{op}/Gene_coverage-{read_number}-{read_size}.csv', lineterminator=None)

    end = time.time()
    print(f'>> Programme Done, design process ran for {round((end - start)/60,1)} min')

    return 0

def main_amplicon_no(args):
    print("========== Amplicon Number: User Setting ==========")
    print(f"Amplicon Size: {args.amplicon_size}")
    print(f"SNP Priority: {args.snp_priority}")
    print(f"Reference Genome: {args.reference_genome}")
    print(f"Target Coverage: {args.target_coverage * 100}%")
    print(f"Graphic Option: {args.graphic_option}")
    print(f"Output Folder Path: {args.output_folder_path}")
    print("===================================================")
    # test run: python main.py amplicon_no -s variants.csv -ref MTB-h37rv_asm19595v2-eg18.fa -op ../test -a 400 -c 1 -sp -sp_f spacers.bed
    # test run: python main.py amplicon_no -a 400 -op ../test -g
    # test run: python main.py amplicon_no -a 1000 -op ../test -g
    full_data = pd.read_csv(args.snp_priority)
    full_data = full_data[~full_data['drugs'].isna()]
    full_data = full_data.sort_values(by=['genome_pos'])
    full_data = full_data.reset_index(drop=True)
    full_data['weight'] = full_data['freq']
    ref_genome = args.reference_genome
    target_coverage = args.target_coverage
    read_size = args.amplicon_size
    output_path = args.output_folder_path
    graphics = args.graphic_option
    gene_coverage = Amplicon_no.place_amplicon_search(full_data, target_coverage, read_size, wa.genome_size(ref_genome),output_path, graphics)
    return 0
    
def main_plotting(args):
    # test run: python main.py plotting -s variants.csv -gff MTB-h37rv_asm19595v2-eg18.gff -ap ../test/Primer_design-accepted_primers-30-400.csv -rp ../test/Primer_design-accepted_primers-30-400.csv -op ../test
    # test run: python main.py plotting -ap ../test/Amplicon_design_output/Primer_design-accepted_primers-42-400.csv -rp ../db/reference_design.csv -op ../test -r 400
    # test run: python main.py plotting -ap ../test/Amplicon_design_output/Primer_design-accepted_primers-30-1000.csv -rp ../db/reference_design.csv -op ../test -r 1000
    print("========== Plotting: User Settings ==========")
    print(f"SNP Priority: {args.snp_priority}")
    print(f"Accepted Primers: {args.accepted_primers}")
    print(f"GFF Feature file: {args.gff_features}")
    print(f"Reference Design: {args.reference_design}")
    print(f"Read Size: {args.read_size}")
    print(f"Output Folder Path: {args.output_folder_path}")
    print("============================================")
    priority = args.snp_priority
    accepted_primers = args.accepted_primers
    gff = args.gff_features
    reference_design = args.reference_design
    output_dir = args.output_folder_path
    read_size = args.read_size
    p.plotting(priority, read_size, accepted_primers, gff, reference_design, output_dir)
    return 0
    
# %%
# if __name__ == "__main__":
#     parser = argparse.ArgumentParser(prog='Amplicon designer for TB', 
#                                     description='Amplicon design, list of specific genes that can be priotised: rpoB,katG,embB,pncA,rpsL,rrs,ethA,fabG1,gyrA,gid,inhA,ethR,rpoC,ahpC,gyrB,folC,tlyA,alr,embA,thyA,eis',
#                                     formatter_class=argparse.ArgumentDefaultsHelpFormatter)
    
#     subparsers = parser.add_subparsers(dest="command", help="Task to perform")

#     ###### Design pipeline
#     parser_sub = subparsers.add_parser('design', help='Run whole design pipeline', formatter_class=ArgumentDefaultsRichHelpFormatter)
#     input=parser_sub.add_argument_group("Input options")
#     # parser.add_argument('-c','--country_file', type = str, help = 'SNP priority CSV files (default: collated global 50k clinical TB samples)', default='variants.csv', default=None)
#     # in
#     input.add_argument('-s','--snp_priority', type = str, help = 'SNP priority CSV files (default: collated global 50k clinical TB samples)', default='../db/variants.csv')
#     input.add_argument('-ref','--reference_genome', type = str, help = 'reference fasta file (default: MTB-h37rv genome)', default='../db/MTB-h37rv_asm19595v2-eg18.fa')
#     input.add_argument('-sp_f','--spoligo_sequencing_file', type = str, help = 'Custom spoligotype range files (default: TB spligotype space ranges)', default = '../db/spacers.bed')
#     input.add_argument('-as','--all_snps', type = str, help = 'All SNPs in the reference genome', default = '../db/all_snps.csv')
    
#     #design
#     setting=parser_sub.add_argument_group("Design options")
#     setting.add_argument('-a','--amplicon_size', type = int, help = 'Amplicon size', default=400)
#     setting.add_argument('-p','--padding_size', type = int, help = 'Size of padding on each side of the target sequence during primer design', default=None)
#     setting.add_argument('-sn','--specific_amplicon_no', type = int, help = 'number of amplicon dedicated to amplifying specific genes', default=0 )
#     setting.add_argument('-sg','--specific_amplicon_gene', type = str, help = 'give a list of gene names separated by Lineage ', default='')
#     setting.add_argument('-nn','--non-specific_amplicon_no', type = int, help = 'number of amplicon dedicated to amplifying all SNPs in all genes according the importants list', default=20)
#     setting.add_argument('-g','--graphic_option', action='store_true', help = 'output graphic on amplicon coverage to visualise the running of the algorithm', default = False)
#     setting.add_argument('-sc','--spoligo_coverage', action='store_true', help = 'Whether to amplify Spoligotype', default = False)

#     # out
#     output=parser_sub.add_argument_group("Output options")
#     output.add_argument('-op','--output_folder_path', default = '', type = str, help = 'output_folder_path (accepted_primers, SNP_inclusion, gene_covered)', required=True)
#     parser_sub.set_defaults(func=main)
    
#     ###### Amplicon number estimates
#     parser_sub = subparsers.add_parser('amplicon_no', help='Amplicon number estimates', formatter_class=ArgumentDefaultsRichHelpFormatter)
#     input=parser_sub.add_argument_group("input options")
#     input.add_argument('-s','--snp_priority', type = str, help = 'SNP priority CSV files (default: collated global 50k clinical TB samples)', default='../db/variants.csv')
#     input.add_argument('-sc_f','--spoligo_sequencing_file', type = str, help = 'Custom spoligotype range files (default: TB spligotype space ranges)', default = '../db/spacers.bed')
#     input.add_argument('-ref','--reference_genome', type = str, help = 'reference fasta file (default: MTB-h37rv genome)', default='../db/MTB-h37rv_asm19595v2-eg18.fa')
    
#     #design
#     setting=parser_sub.add_argument_group("Amplicon options")
#     setting.add_argument('-a','--amplicon_size', type = int, help = 'Amplicon size', default=400)
#     setting.add_argument('-c','--target_coverage', type = int, help = 'target coverage of SNPs default: full coverage(1)', default=1)
#     # setting.add_argument('-sc','--spoligotype_sequencing', action='store_true', help = 'Whether to do a separate run on chekcing the number of amplicon needed to cover the spligotypes', default= False)
#     # setting.add_argument('-ap','--amplicon_sequencing', action='store_true', help = 'Whether to calculate amplicon number for SNP coverage', default = True)
#     setting.add_argument('-g','--graphic_option', action='store_true', help = 'output graphic on amplicon coverage to visualise the running of the algorithm', default = False)
    
#     # out
#     output=parser_sub.add_argument_group("Output options")
#     output.add_argument('-op','--output_folder_path', default = '', type = str, help = 'output_folder_path (Amplicon number estimate graphics)', required=True)
#     parser_sub.set_defaults(func=main)
    
#     parser_sub.set_defaults(func=main_amplicon_no)

#     # output=parser_sub.add_argument_group("Output options")
#     # output.add_argument('-op','--output_folder_path', default = './', type = str, help = 'output folder path for covered ranges')
#     # output.add_argument('-op','--output_folder_path', default = '', type = str, help = 'output folder path for covered ranges')

#     ###### Visualisation of designed amplicons
#     parser_sub = subparsers.add_parser('plotting', help='Visualised the designed amplicons', formatter_class=ArgumentDefaultsRichHelpFormatter)
#     #input
#     input=parser_sub.add_argument_group("input options")
#     input.add_argument('-s','--snp_priority', type = str, help = 'SNP priority CSV files (default: collated global 50k clinical TB samples)', default='../db/variants.csv')
#     input.add_argument('-gff','--gff_features', type = str, help = 'genomic feature file .gff for the corresponding genome', default='../db/MTB-h37rv_asm19595v2-eg18.gff')
#     input.add_argument('-ap','--accepted_primers', type = str, help = 'primer design output file from desgin function', required=True)
#     input.add_argument('-rp','--reference_design', type = str, help = '(reference) design that can be plotted against the designed amplicons for comparision', default=None)
#     input.add_argument('-r','--read_size', type = str, help = 'size of the designed amplicons', default='unknown-')
    
#     #output
#     output=parser_sub.add_argument_group("output options")
#     output.add_argument('-op','--output_folder_path', default = '', type = str, help = 'output_folder_path (accepted_primers, SNP_inclusion, gene_covered)', required=True)
#     parser_sub.set_defaults(func=main_plotting)

#     args = parser.parse_args()
#     if args.command == 'design':
#         main(args)
#     if args.command == 'amplicon_no':
#         main_amplicon_no(args)
#     if args.command == 'plotting':
#         main_plotting(args)

def cli():
    # if args.db==None:
    db = '/'.join(__file__.split('/')[:-1]) + '/db'
    
    # print(os.listdir(db_dir))
    """
    Command line interface for TOAST - Tuberculosis Optimized Amplicon Sequencing Tool.
    
    Design Function - (design)
        Purpose: To design specific amplicons for TB genes.
        Inputs:
        SNP priorities, reference genomes, spoligotype sequencing files, user defined primers.
        Alternative input of min amplicon size, max amplicon size, step size, count for each step size can be inputed to crease different sized amplicons.
        Settings:
        Amplicon size, padding size, specific/non-specific amplicon numbers.
        Option for graphical output.
        Outputs:
        Files in specified output folder path.

        
    Amplicon Number Estimates Function - (amplicon_no)
        Purpose: To estimate the number of amplicons for SNP coverage in TB genomic studies.
        Inputs:
        SNP priority files, spoligotype sequencing files, reference genomes.
        Settings:
        Amplicon size, target coverage, graphical output option.
        Outputs:
        Estimates and graphics in the specified output folder path.
        
    Plotting Function - (plotting)
        Purpose: To visualize designed amplicons for analysis.
        Inputs:
        SNP priority files, GFF files, accepted primers, reference design.
        Settings:
        Read size specification.
        Outputs:
        Visualization graphics and outputs in specified output folder path.
    """
    print("""
    Command line interface for TOAST - Tuberculosis Optimized Amplicon Sequencing Tool
    
    Design Function - (design)
        - Purpose: To design specific amplicons for TB genes.
        - Inputs:
            SNP priorities, reference genomes, spoligotype sequencing files.
        - Settings:
            Amplicon size, padding size, specific/non-specific amplicon numbers.
            Option for graphical output.
        - Outputs:
            Files in specified output folder path.
        
    Amplicon Number Estimates Function - (amplicon_no)
        - Purpose: To estimate the number of amplicons for SNP coverage in TB genomic studies.
        - Inputs:
            SNP priority files, spoligotype sequencing files, reference genomes.
        - Settings:
            Amplicon size, target coverage, graphical output option.
        - Outputs:
            Estimates and graphics in the specified output folder path.
        
    Plotting Function - (plotting)
        - Purpose: To visualize designed amplicons for analysis.
        - Inputs:
            SNP priority files, GFF files, accepted primers, reference design.
        - Settings:
            Read size specification.
        - Outputs:
            Visualization graphics and outputs in specified output folder path.
    """)
    
    parser = argparse.ArgumentParser(prog='Amplicon designer for TB', 
                                    description='Amplicon design, list of specific genes that can be priotised: rpoB,katG,embB,pncA,rpsL,rrs,ethA,fabG1,gyrA,gid,inhA,ethR,rpoC,ahpC,gyrB,folC,tlyA,alr,embA,thyA,eis (given the default SNP database)',
                                    formatter_class=argparse.ArgumentDefaultsHelpFormatter)
    
    subparsers = parser.add_subparsers(dest="command", help="Task to perform")

    ###### Design pipeline
    parser_sub = subparsers.add_parser('design', help='Run whole design pipeline', formatter_class=ArgumentDefaultsRichHelpFormatter)
    input=parser_sub.add_argument_group("Input options")
    # parser.add_argument('-c','--country_file', type = str, help = 'SNP priority CSV files (default: collated global 50k clinical TB samples)', default='variants.csv', default=None)
    # in
    # input.add_argument('-h', '--help', action='CustomHelpAction', help='help')
    input.add_argument('-s','--snp_priority', type = str, help = 'SNP priority CSV files (default: collated global 50k clinical TB samples)', default=f'{db}/variants.csv')
    input.add_argument('-ref','--reference_genome', type = str, help = 'reference fasta file (default: MTB-h37rv genome)', default=f'{db}/MTB-h37rv_asm19595v2-eg18.fa')
    input.add_argument('-sp_f','--spoligo_sequencing_file', type = str, help = 'Custom spoligotype range files (default: TB spligotype space ranges)', default = f'{db}/spacers.bed')
    input.add_argument('-as','--all_snps', type = str, help = 'All SNPs in the reference genome', default = f'{db}/all_snps.csv')
    input.add_argument('-ud','--user_defined_primers', type = str, help = 'user defined amplicon designs', default = None)
    input.add_argument('-gff','--gff3_file', type = str, help = 'Genomic feature file .gff (version3) for the corresponding genome', default=f'{db}/MTB-h37rv_asm19595v2-eg18.gff')
    input.add_argument('-seg','--segmented_amplicon_size', type = str, help = 'design various sized amplicon, provide input in the following comma separated format: min_size, max_size, step_size, count for each step size', default=None)
    #design
    setting=parser_sub.add_argument_group("Design options")
    setting.add_argument('-a','--amplicon_size', type = int, help = 'Amplicon size', default=400)
    setting.add_argument('-p','--padding_size', type = int, help = 'Size of padding on each side of the target sequence during primer design (default: amplicon_size/6)', default=None)
    setting.add_argument('-sn','--specific_amplicon_no', type = int, help = 'Number of amplicon dedicated to amplifying specific genes', default=None)
    setting.add_argument('-sg','--specific_amplicon_gene', type = str, help = 'Provide a list of gene names separated by comma <,>', default='')
    setting.add_argument('-nn','--non-specific_amplicon_no', type = int, help = 'Number of amplicon dedicated to amplifying all SNPs in all genes according the importants list', default=10)
    setting.add_argument('-g','--graphic_option', action='store_true', help = 'Output graphic on amplicon coverage to visualise the running of the algorithm', default = False)
    setting.add_argument('-sc','--spoligo_coverage', action='store_true', help = 'Whether to amplify Spoligotype', default = False)
    setting.add_argument('-set','--global_args', help = 'Amplicon search setting', default = f'{db}/default_primer_design_setting.json')
    setting.add_argument('-mg','--multiplexing', action='store_true', help = 'Whether include multiplex grouping', default = True)

    # out
    output=parser_sub.add_argument_group("Output options")
    output.add_argument('-op','--output_folder_path', type = str, help = 'Output_folder_path (accepted_primers, Mutation_inclusion, gene_covered)', required=True)
    parser_sub.set_defaults(func=main)
    
    ###### Amplicon number estimates
    parser_sub = subparsers.add_parser('amplicon_no', help='Amplicon number estimates', formatter_class=ArgumentDefaultsRichHelpFormatter)
    # input.add_argument('-h', '--help', action='CustomHelpAction', help='help')
    input=parser_sub.add_argument_group("input options")
    input.add_argument('-s','--snp_priority', type = str, help = 'SNP priority CSV files (default: collated global 50k clinical TB samples)', default=f'{db}/variants.csv')
    # input.add_argument('-sc_f','--spoligo_sequencing_file', type = str, help = 'Custom spoligotype range files (default: TB spligotype space ranges)', default = f'{db}/spacers.bed')
    input.add_argument('-ref','--reference_genome', type = str, help = 'Reference fasta file (default: MTB-h37rv genome)', default=f'{db}/MTB-h37rv_asm19595v2-eg18.fa')
    
    #design
    setting=parser_sub.add_argument_group("Amplicon options")
    setting.add_argument('-a','--amplicon_size', type = int, help = 'Amplicon size', default=400)
    setting.add_argument('-c','--target_coverage', type = int, help = 'Target coverage of SNPs default: full coverage(1)', default=1)
    # setting.add_argument('-sc','--spoligotype_sequencing', action='store_true', help = 'Whether to do a separate run on chekcing the number of amplicon needed to cover the spligotypes', default= False)
    # setting.add_argument('-ap','--amplicon_sequencing', action='store_true', help = 'Whether to calculate amplicon number for SNP coverage', default = True)
    setting.add_argument('-g','--graphic_option', action='store_true', help = 'Output graphic on amplicon coverage to visualise the running of the algorithm', default = False)
    
    # out
    output=parser_sub.add_argument_group("Output options")
    output.add_argument('-op','--output_folder_path', type = str, help = 'Output_folder_path (Amplicon number estimate graphics)', required=True)    
    parser_sub.set_defaults(func=main_amplicon_no)

    # output=parser_sub.add_argument_group("Output options")
    # output.add_argument('-op','--output_folder_path', default = './', type = str, help = 'output folder path for covered ranges')
    # output.add_argument('-op','--output_folder_path', default = '', type = str, help = 'output folder path for covered ranges')

    ###### Visualisation of designed amplicons
    parser_sub = subparsers.add_parser('plotting', help='Visualised the designed amplicons', formatter_class=ArgumentDefaultsRichHelpFormatter)
    #input
    # input.add_argument('-h', '--help', action='CustomHelpAction', help='help')
    input=parser_sub.add_argument_group("input options")
    input.add_argument('-s','--snp_priority', type = str, help = 'SNP priority CSV files (default: collated global 50k clinical TB samples)', default=f'{db}/variants.csv')
    input.add_argument('-gff','--gff_features', type = str, help = 'Genomic feature file .gff for the corresponding genome', default=f'{db}/MTB-h37rv_asm19595v2-eg18.gff')
    input.add_argument('-ap','--accepted_primers', type = str, help = 'Primer design output file from desgin function', required=True)
    input.add_argument('-rp','--reference_design', type = str, help = '(reference) Design that can be plotted against the designed amplicons for comparision', default=None)
    input.add_argument('-r','--read_size', type = str, help = 'Size of the designed amplicons', default='unknown-')
    
    #output
    output=parser_sub.add_argument_group("output options")
    output.add_argument('-op','--output_folder_path', default = '', type = str, help = 'Output_folder_path (accepted_primers, Mutation_inclusion, gene_covered)', required=True)
    parser_sub.set_defaults(func=main_plotting)

    args = parser.parse_args()
    if args.command == 'design':
        main(args)
    if args.command == 'amplicon_no':
        main_amplicon_no(args)
    if args.command == 'plotting':
        main_plotting(args)